/* Aditi Raghavan. Parts required: Arduino Uno, Piezo Speaker, 
 * Sound Detector, Pulse rate monitor. */

const int AUDIOPIN = A1;
const int PULSEPIN = A0;
const int POTPIN = A2;
int speakerPin = 8;
int Signal;
int currMode;
int currAudioMode;
int lastAudioMode = 0;
int lastMode = 0;
int audioLevel;
//Taken from https://www.arduino.cc/en/Tutorial/Smoothing
const int numReadings = 50;
int readings[numReadings];      // the readings from the analog input
int readIndex = 0;              // the index of the current reading
int total = 0;                  // the running total
int average = 0;
uint32_t reg = 0xfeedfaceUL;
bool reactiveMode = false;
long timeElapsed;
long oldTime;

void setup() {
  pinMode(AUDIOPIN, INPUT);
  Serial.begin(9600);
  for (int thisReading = 0; thisReading < numReadings; thisReading++) {
    readings[thisReading] = 0;
  }
  pinMode(POTPIN, INPUT);
  pinMode(speakerPin, OUTPUT);
   Serial.println(analogRead(POTPIN));
  timeElapsed = map(analogRead(POTPIN), 0, 1024, 0, 50000);
  Serial.println(timeElapsed);

}

void loop() {

    if(!reactiveMode){
      noiseLoop(timeElapsed);
    } else { doReactive();} 
}

void doReactive(){  if(reactiveMode){
  audioLevel = analogRead(AUDIOPIN);
  currAudioMode = map(audioLevel, 0, 1024, 0, 3);
  if (currAudioMode != lastAudioMode) { Serial.println("Change Sound");}
  Signal = analogRead(PULSEPIN);
  if (Signal > 400 && Signal < 1000) {
    total = total - readings[readIndex];
    readings[readIndex] = Signal;
    total = total + readings[readIndex];
    readIndex = readIndex + 1;
    // if we're at the end of the array...
    if (readIndex >= numReadings) {
      // ...wrap around to the beginning:
      readIndex = 0;
    }
    average = abs(total / numReadings);
    currMode = map(abs(average), 400, 1000, 0, 3);
  }
  if (lastMode != currMode) {
    lastMode = currMode;
    Serial.println(Signal);
    Serial.println("Heartbeat change");
    speakerMode(lastMode);
  } else if (currAudioMode != lastAudioMode) {
    lastAudioMode = currAudioMode;
    Serial.println("Sound level change");
    speakerMode(lastAudioMode);
  }
  }
  else{
    noiseLoop(timeElapsed);
    delay(50);
  }
}

void speakerMode(int thresh) {
  if(thresh > 1){
      noiseLoop(30);
  }
}

void noiseLoop(int timeElapsed){
  int count = 0 ;
  Serial.println("In noise loop");
  oldTime = millis();
  for(int i=0; i < 10000; i++){
      generateNoise();
  }
  Serial.println("Out noise loop");
  reactiveMode = true;
  
}

//https://arduino.stackexchange.com/questions/6715/audio-frequency-white-noise-generation-using-arduino-mini-pro
//This amazing nosie code is from the above link!

void generateNoise(){
   unsigned long int newr;
   unsigned char lobit;
   unsigned char b31, b29, b25, b24;
   b31 = (reg & (1L << 31)) >> 31;
   b29 = (reg & (1L << 29)) >> 29;
   b25 = (reg & (1L << 25)) >> 25;
   b24 = (reg & (1L << 24)) >> 24;
   lobit = b31 ^ b29 ^ b25 ^ b24;
   newr = (reg << 1) | lobit;
   reg = newr;
   digitalWrite (speakerPin, reg & 1);
   delayMicroseconds (50);}
